part of datagrid;

abstract class DataCellBase {
  GridCell _columnElement;

  Key _key;

  DataGridCellStyle _cellStyle;

  GridCellRendererBase _renderer;

  CellType _cellType;

  bool _isVisible = true;

  bool _isEnsured = false;

  DataRowBase _dataRow;

  bool _isDirty = false;

  String _displayText;

  int get columnIndex => this._columnIndex;
  int _columnIndex = -1;

  set columnIndex(int value) => this._columnIndex = value;

  int get rowIndex => this._rowIndex;
  int _rowIndex = -1;

  set rowIndex(int newValue) => this._rowIndex = newValue;

  GridColumn get gridColumn => this._gridColumn;
  GridColumn _gridColumn;

  set gridColumn(GridColumn value) => this._gridColumn = value;

  Object get cellValue => this._cellValue;
  Object _cellValue;

  set cellValue(Object newCellValue) {
    _cellValue = newCellValue;
  }

  bool get isVisible => this._isVisible;

  GridCell _onInitializeColumnElement(bool isInEdit) {
    return null;
  }

  void _updateColumn() {}

  void _onTouchUp() {
    if (this._dataRow != null) {
      final _DataGridSettings dataGridSettings =
          this._dataRow._dataGridStateDetails();
      if (this.rowIndex <=
              _GridIndexResolver.getHeaderIndex(dataGridSettings) ||
          dataGridSettings.selectionMode == SelectionMode.none) return;

      final RowColumnIndex currentRowColumnIndex =
          RowColumnIndex(this.rowIndex, this.columnIndex);
      dataGridSettings.rowSelectionManager.handleTap(currentRowColumnIndex);
    }
  }

  bool get isCurrentCell => this._isCurrentCell;
  bool _isCurrentCell = false;

  set isCurrentCell(bool isCurrentCell) {
    this._isCurrentCell = isCurrentCell;
  }
}
