part of datagrid;

class DataRow extends DataRowBase {
  DataRow();

  @override
  void _onGenerateVisibleColumns(_VisibleLinesCollection visibleColumnLines) {
    this._visibleColumns.clear();

    var startColumnIndex = 0;
    var endColumnIndex = -1;

    for (int i = 0; i < 3; i++) {
      if (i == 0) {
        if (visibleColumnLines.firstBodyVisibleIndex <= 0) continue;

        startColumnIndex = 0;
        endColumnIndex =
            visibleColumnLines[visibleColumnLines.firstBodyVisibleIndex - 1]
                .lineIndex;
      } else if (i == 1) {
        if ((visibleColumnLines.firstBodyVisibleIndex <= 0 &&
            visibleColumnLines.lastBodyVisibleIndex < 0)) continue;

        if (visibleColumnLines.length >
            visibleColumnLines.firstBodyVisibleIndex)
          startColumnIndex =
              visibleColumnLines[visibleColumnLines.firstBodyVisibleIndex]
                  .lineIndex;
        else
          continue;

        endColumnIndex =
            visibleColumnLines[visibleColumnLines.lastBodyVisibleIndex]
                .lineIndex;
      } else {
        if (visibleColumnLines.firstFooterVisibleIndex >=
            visibleColumnLines.length) continue;

        startColumnIndex =
            visibleColumnLines[visibleColumnLines.firstFooterVisibleIndex]
                .lineIndex;
        endColumnIndex =
            visibleColumnLines[visibleColumnLines.length - 1].lineIndex;
      }

      for (int index = startColumnIndex; index <= endColumnIndex; index++) {
        var dc = this._createColumn(index);
        this._visibleColumns.add(dc);
        dc = null;
      }
    }
  }

  @override
  void _ensureColumns(_VisibleLinesCollection visibleColumnLines) {
    for (int i = 0; i < this._visibleColumns.length; i++) {
      _visibleColumns[i]._isEnsured = false;
    }

    var startColumnIndex = 0;
    var endColumnIndex = -1;

    for (int i = 0; i < 3; i++) {
      if (i == 0) {
        if (visibleColumnLines.firstBodyVisibleIndex <= 0) continue;

        startColumnIndex = 0;
        endColumnIndex =
            visibleColumnLines[visibleColumnLines.firstBodyVisibleIndex - 1]
                .lineIndex;
      } else if (i == 1) {
        if ((visibleColumnLines.firstBodyVisibleIndex <= 0 &&
            visibleColumnLines.lastBodyVisibleIndex < 0)) continue;

        if (visibleColumnLines.length >
            visibleColumnLines.firstBodyVisibleIndex)
          startColumnIndex =
              visibleColumnLines[visibleColumnLines.firstBodyVisibleIndex]
                  .lineIndex;
        else
          continue;

        endColumnIndex =
            visibleColumnLines[visibleColumnLines.lastBodyVisibleIndex]
                .lineIndex;
      } else {
        if (visibleColumnLines.firstFooterVisibleIndex >=
            visibleColumnLines.length) continue;

        startColumnIndex =
            visibleColumnLines[visibleColumnLines.firstFooterVisibleIndex]
                .lineIndex;
        endColumnIndex =
            visibleColumnLines[visibleColumnLines.length - 1].lineIndex;
      }

      for (int index = startColumnIndex; index <= endColumnIndex; index++) {
        if (this._indexer(index) == null) {
          var dataCell = this.__indexer(startColumnIndex, endColumnIndex);
          if (dataCell == null) {
            dataCell = this._visibleColumns.any((col) =>
                    col.columnIndex == -1 &&
                    col._cellType != CellType.indentCell)
                ? this._visibleColumns.firstWhere((col) =>
                    col.columnIndex == -1 &&
                    col._cellType != CellType.indentCell)
                : null;
          }

          this._updateColumn(dataCell, index);
          dataCell = null;
        }

        var dc = this._indexer(index);
        if (dc != null) {
          if (!dc._isVisible) {
            dc._isVisible = true;
          }
        } else {
          dc = this._createColumn(index);
          this._visibleColumns.add(dc);
        }

        dc._isEnsured = true;
        dc = null;
      }
    }

    for (var col in this._visibleColumns) {
      if (!col._isEnsured || col.columnIndex == -1) {
        col._isVisible = false;
      }
    }
  }

  DataCellBase _createColumn(int index, {int columnHeightIncrementation = 0}) {
    final _DataGridSettings dataGridSettings = this._dataGridStateDetails();
    var dc = new DataCell();
    dc._key = ObjectKey(dc);
    dc._dataRow = this;
    dc.columnIndex = index;
    dc.rowIndex = this.rowIndex;
    var columnIndex = _GridIndexResolver.resolveToGridVisibleColumnIndex(
        dataGridSettings, index);
    dc.gridColumn = dataGridSettings.columns[columnIndex];
    this._checkForCurrentCell(dataGridSettings, dc);
    if (this.rowIndex == _GridIndexResolver.getHeaderIndex(dataGridSettings) &&
        this.rowIndex >= 0) {
      dc._renderer = dataGridSettings.cellRenderers["ColumnHeader"];
      dc._cellType = CellType.headerCell;
    } else {
      dc._renderer = dc.gridColumn._cellType.isNotEmpty
          ? dataGridSettings.cellRenderers[dc.gridColumn._cellType]
          : dataGridSettings.cellRenderers["TextField"];
      dc._cellType = CellType.gridCell;
    }

    dc._columnElement = dc._onInitializeColumnElement(false);
    return dc;
  }

  @override
  void _rowIndexChanged() {
    super._rowIndexChanged();
  }

  DataCellBase _indexer(int index) {
    for (int i = 0; i < this._visibleColumns.length; i++) {
      if (_visibleColumns[i].columnIndex == index) {
        return this._visibleColumns[i];
      }
    }

    return null;
  }

  DataCellBase __indexer(int startColumnIndex, int endColumnIndex) {
    for (int i = 0; i < _visibleColumns.length; i++) {
      var cell = _visibleColumns[i];
      if (cell.gridColumn != null &&
          (cell.columnIndex < 0 ||
              cell.columnIndex < startColumnIndex ||
              cell.columnIndex > endColumnIndex) &&
          !cell._isEnsured) {
        return cell;
      }
    }

    return null;
  }

  void _updateColumn(DataCellBase dc, int index) {
    final _DataGridSettings dataGridSettings = this._dataGridStateDetails();
    if (dc != null) {
      if (index < 0 || index >= dataGridSettings.container.columnCount) {
        dc._isVisible = false;
      } else {
        dc.columnIndex = index;
        dc.rowIndex = this.rowIndex;
        dc._key = dc._key;
        dc._isVisible = true;
        var columnIndex = _GridIndexResolver.resolveToGridVisibleColumnIndex(
            dataGridSettings, index);
        dc.gridColumn = dataGridSettings.columns[columnIndex];
        this._checkForCurrentCell(dataGridSettings, dc);
        this._updateRenderer(dataGridSettings, dc, dc.gridColumn);
        dc._columnElement = dc._onInitializeColumnElement(false);
        dc._isEnsured = true;
      }

      if (dc._isVisible != true) {
        dc._isVisible = true;
      }
    } else {
      dc = this._createColumn(index);
      this._visibleColumns.add(dc);
    }
  }

  void _updateRenderer(_DataGridSettings dataGridSettings,
      DataCellBase dataColumn, GridColumn column) {
    var newRenderer;
    if (this.rowRegion == RowRegion.header &&
        this.rowType == RowType.headerRow) {
      newRenderer = dataGridSettings.cellRenderers["ColumnHeader"];
      dataColumn._cellType = CellType.headerCell;
    } else {
      newRenderer = dataGridSettings.cellRenderers[column._cellType];
      dataColumn._cellType = CellType.gridCell;
    }

    dataColumn._renderer = newRenderer;
    newRenderer = null;
  }

  void _checkForCurrentCell(_DataGridSettings dataGridSettings, DataCell dc) {
    if (dataGridSettings.navigationMode == GridNavigationMode.cell) {
      final _CurrentCellManager currentCellManager =
          dataGridSettings.currentCell;
      if (currentCellManager.columnIndex != -1 &&
          currentCellManager.rowIndex != -1 &&
          currentCellManager.rowIndex == this.rowIndex &&
          currentCellManager.columnIndex == dc.columnIndex) {
        dc.isCurrentCell = true;
      } else {
        dc.isCurrentCell = false;
      }
    }
  }
}
