part of datagrid;

abstract class DataRowBase {
  _DataGridStateDetails _dataGridStateDetails;

  Key _key;

  bool _isDirty = false;

  bool _isEnsured = false;

  bool _isVisible = true;

  List<DataCellBase> _visibleColumns = [];

  int get rowIndex => this._rowIndex;
  int _rowIndex = -1;

  set rowIndex(int newValue) => this._rowIndex = newValue;

  RowType get rowType => this._rowType;
  RowType _rowType = RowType.headerRow;

  set rowType(RowType newValue) => this._rowType = newValue;

  bool get isVisible => this._isVisible;

  DataGridCellStyle get rowStyle => this._rowStyle;
  DataGridCellStyle _rowStyle;

  set rowStyle(DataGridCellStyle newStyle) => this._rowStyle = newStyle;

  RowRegion get rowRegion => this._rowRegion;
  RowRegion _rowRegion = RowRegion.header;

  set rowRegion(RowRegion newValue) => this._rowRegion = newValue;

  void _rowIndexChanged() {
    if (this.rowIndex < 0) {
      return;
    }

    this._visibleColumns.forEach((col) {
      col.rowIndex = this.rowIndex;
      col._dataRow = this;
      col._updateColumn();
    });
  }

  void _onGenerateVisibleColumns(_VisibleLinesCollection visibleColumnLines) {}

  //Required and currently used properties
  void _initializeDataRow(_VisibleLinesCollection visibleColumnLines) {
    this._onGenerateVisibleColumns(visibleColumnLines);
  }

  void _ensureColumns(_VisibleLinesCollection visibleColumnLines) {}

  // Used in implementation
  _VisibleLineInfo _getColumnVisibleLineInfo(int index) {
    return this
        ._dataGridStateDetails()
        .container
        .scrollColumns
        .getVisibleLineAtLineIndex(index);
  }

  double _getColumnSize(int index, bool lineNull) {
    if (lineNull) {
      var currentPos = this
          ._dataGridStateDetails()
          .container
          .scrollColumns
          .rangeToRegionPoints(index, index, true);
      return currentPos[1].length;
    }

    var line = this._getColumnVisibleLineInfo(index);
    if (line == null) {
      return 0;
    }

    return line.size;
  }

  bool get isSelectedRow => this._isSelectedRow;
  bool _isSelectedRow = false;

  set isSelectedRow(bool newValue) {
    if (this._isSelectedRow != newValue) {
      this._isSelectedRow = newValue;
      this._visibleColumns?.forEach((dataCell) {
        dataCell._isDirty = true;
        dataCell._updateColumn();
      });
    }
  }

  StylePreference _stylePreference = StylePreference.selection;

  bool get isCurrentRow => this._isCurrentRow;
  bool _isCurrentRow = false;

  set isCurrentRow(bool isCurrentRow) {
    this._isCurrentRow = isCurrentRow;
  }
}
