part of datagrid;

/// Describes the possible values for row region.
/// These values are used to update the row region for the row elements in a [SfDataGrid] control.
enum RowRegion {
  header,
  footer,
  body,
}

/// Describes the possible values for row type.
/// These values are used to update the row type of the row elements in a [SfDataGrid] control.
enum RowType {
  headerRow,
  dataRow,
}

enum CellType {
  headerCell,
  gridCell,
  indentCell,
  rowHeaderCell,
}

enum GridLinesVisibility {
  none,
  both,
  vertical,
  horizontal,
}

enum ColumnWidthMode {
  none,
  header,
  auto,
  cells,
  lastColumnFill,
  fill,
}

enum ColumnWidthCalculationMode {
  textSize,
  textLength,
}

enum ColumnWidthCalculationRange {
  allRows,
  visibleRows,
}

/// Decides how the selection is applied.
enum SelectionMode {
  none,

  ///Specifies that only one row can be selected.
  single,

  ///Specifies that only one row can be selected, and selected row can be de-selected when again tapping on that selected row.
  singleDeselect,

  ///Specifies that multiple rows can be selected.
  multiple
}

enum StylePreference {
  //Selection should be applied above the applied cell/row style.
  selection,

  //Selection and cell/row style should be applied.
  styleAndSelection
}

enum GridNavigationMode {
  ///Specifies that the current cell can be shown to notify the currently activated cell for cell wise navigation.
  cell,

  ///Specifies that the selection can be moved among the rows alone and current cell will not be shown.
  row
}
