part of datagrid;

/// A tree leaf with value and summary information.
///
/// * T - _required_ - Represents a generic type parameter
class _GenericTreeTableWithSummaryEntryBase<T>
    extends _TreeTableWithSummaryEntryBase {
  /// Initializes a new instance of the _GenericTreeTableWithSummaryEntryBase class.
  _GenericTreeTableWithSummaryEntryBase();

  List list;

  /// Initializes a new instance of the _GenericTreeTableWithSummaryEntryBase class.
  ///
  /// * tree - _required_ - Tree instance
  /// * value - _required_ - Tree value
  _GenericTreeTableWithSummaryEntryBase.treeTable(_TreeTable tree, T value) {
    super.value = value;
    this.tree = tree;
  }

  /// Initializes a new instance of the _GenericTreeTableWithSummaryEntryBase class.
  ///
  /// * tree - _required_ - Tree instance
  /// * value - _required_ -Ttree value
  _GenericTreeTableWithSummaryEntryBase.genericTreeTable(
      _GenericTreeTableWithSummary<T> tree, T value) {
    super.value = value;
    this.tree = tree.internalTree;
  }

  /// Gets the value attached to this leaf.
  T get value => super.value;

  /// Sets the value attached to this leaf.
  set value(Object value) {
    super.value = value;
  }
}

///Tree table summary class
///
/// * T - _required_ - Represents a generic type parameter
class _GenericTreeTableWithSummary<T>
    extends _TreeTableBase //with IListGeneric<_GenericTreeTableWithSummaryEntryBase<T>>
{
  _TreeTableWithSummary _thisTree;

  /// Gets the tag that was associate with the tree
  Object get tag => this._thisTree.tag;

  /// Sets the tag that was associate with the tree
  set tag(Object value) => this._thisTree.tag = value;

  //public GenericBinaryTreeWithSummaryCollection<V> BinaryTreeCollection { get; set; }
  /// Gets an identifier.
  int get identifier => _identifier;
  int _identifier = 0;

  /// Sets an identifier.
  set identifier(int value) {
    if (value == _identifier) return;
    _identifier = value;
  }

  /// Gets the internal thisTree table.
  _TreeTableWithSummary get internalTree => this._thisTree;

  ///Initializes a new instance of the [GenericTreeTableWithSummary]` class.
  ///
  /// * sorted - _required_ - boolean value
  _GenericTreeTableWithSummary(bool sorted) {
    this._thisTree = _TreeTableWithSummary(sorted)..tag = this;
  }

  /// Gets the root node.
  _TreeTableNodeBase get root => this._thisTree.root;

  /// Gets a value indicating whether thisTree is sorted.
  bool get sorted => this._thisTree.sorted;

  /// Gets the comparer used by sorted trees.
  Comparable get comparer => this._thisTree.comparer;

  /// Sets the comparer used by sorted trees.
  set comparer(Comparable value) {
    this._thisTree.comparer;
  }

  /// Gets a value indicating whether the tree was initialize or not.
  bool get isInitializing => this._thisTree.isInitializing;

  /// Optimizes insertion of many items when thisTree is initialized for the first time.
  void beginInit() {
    this._thisTree.beginInit();
  }

  /// Ends optimization of insertion of items when thisTree is initialized for the first time.
  void endInit() {
    this._thisTree.endInit();
  }

  /// Optimized access to a subsequent entry.
  ///
  /// * current - _required_ - current value
  ///
  /// Returns next subsequent entry
  _GenericTreeTableWithSummaryEntryBase<T> getNextEntryBase(
      _GenericTreeTableWithSummaryEntryBase<T> current) {
    return this._thisTree.getNextEntry(current);
  }

  /// Optimized access to a subsequent entry.
  ///
  /// * current - _required_ - current entry
  ///
  /// Returns next subsequent entry

  _TreeTableEntryBase getNextEntry(_TreeTableEntryBase current) {
    return this.getNextEntryBase(current);
  }

  /// Optimized access to the previous entry.
  ///
  /// * current - _required_ - Current item
  ///
  /// Returns previous entry
  _GenericTreeTableWithSummaryEntryBase<T> getPreviousEntryBase(
      _GenericTreeTableWithSummaryEntryBase<T> current) {
    return this._thisTree.getPreviousEntry(current);
  }

  /// Optimized access to the previous entry.
  ///
  /// * current - _required_ - Current entry
  ///
  /// Returns previous entry
  _TreeTableEntryBase getPreviousEntry(_TreeTableEntryBase current) {
    return this.getPreviousEntryBase(current);
  }

  /// Add the key if the collection does not contains the specified key
  ///
  /// * key - _required_ - Key needs to be add in the collection
  /// * entry - _required_ - The collection
  ///
  /// Returns the tree
  _GenericTreeTableWithSummaryEntryBase<T> addIfNotExists(
      Object key, _GenericTreeTableWithSummaryEntryBase<T> entry) {
    return this._thisTree.addIfNotExists(key, entry);
  }

  /// Used to find the index of the specified key
  ///
  /// * key - _required_ - Key value
  ///
  /// Returns the index of the key
  int indexOfKey(Object key) {
    return this._thisTree.indexOfKey(key);
  }

  /// Used to find the key in a TreeTable
  ///
  /// * key - _required_ - Key needs to find
  ///
  /// Returns the instance for TreeTable
  _GenericTreeTableWithSummaryEntryBase<T> findKey(Object key) {
    return this._thisTree.findKey(key);
  }

  /// Used to find the key approximate to the specified key
  ///
  /// * key - _required_ - Key needs to be search
  ///
  /// Returns the value corresponds to the approximate key
  _GenericTreeTableWithSummaryEntryBase<T> findHighestSmallerOrEqualKey(
      Object key) {
    return this._thisTree.findHighestSmallerOrEqualKey(key)
        as _GenericTreeTableWithSummaryEntryBase<T>;
  }

  /// Gets the item at the zero-based index.
  ///
  /// * index - _required_ - Index value
  ///
  /// Returns the Tree value
  operator [](index) {
    return this._thisTree[index] as _GenericTreeTableWithSummaryEntryBase<T>;
  }

  /// Sets the item at the zero-based index.
  operator []=(index, value) {
    this._thisTree[index] = value;
  }

  /// Inserts an item into the collection at the specified index.
  ///
  /// * index - _required_ - The zero-based index at which the item should be inserted.
  /// * item - _required_ - The item to insert. The value must not be a `NULL` reference (Nothing in Visual Basic).
  void insertBase(int index, _GenericTreeTableWithSummaryEntryBase<T> item) {
    this._thisTree.insert(index, item);
  }

  /// Removes the specified item from the collection.
  ///
  /// * item - _required_ - The item to remove from the collection. If the value is NULL or the item is not contained
  /// in the collection, the method will do nothing.
  ///
  /// Returns the removed item
  bool removeBase(_GenericTreeTableWithSummaryEntryBase<T> item) {
    return this._thisTree.remove(item);
  }

  /// Removes the item at the specified index of the collection.
  ///
  /// * index - _required_ - The zero-based index of the item to remove.
  void removeAtBase(int index) {
    this._thisTree.removeAt(index);
  }

  /// Returns the zero-based index of the occurrence of the item in the collection.
  ///
  /// * item - _required_ - The item to locate in the collection. The value can be a `NULL` reference (Nothing in Visual Basic).
  ///
  /// Returns the zero-based index of the occurrence of the item within the entire collection, if found; otherwise `-1`.
  int indexOfBase(_GenericTreeTableWithSummaryEntryBase<T> item) {
    return this._thisTree.indexOf(item);
  }

  /// Gets the number of items contained in the collection.
  int get count => this._thisTree.getCount();

  /// Gets a value indicating whether the collection is read-only.
  ///
  /// Returns true if the collection is read-only. otherwise, false.
  bool get isReadOnly => this._thisTree.isReadOnly;

  /// Adds a value to the end of the collection.
  ///
  /// * item - _required_ - The item to be added to the end of the collection. The value must not be a NULL reference (Nothing in Visual Basic).
  ///
  /// Returns the zero-based collection index at which the value has been added.
  int addBase(_GenericTreeTableWithSummaryEntryBase<T> item) {
    return this._thisTree.add(item);
  }

  /// Add an item to the collection
  ///
  /// * item - _required_ - tree needs to be add in an collection
  void addGeneric(_GenericTreeTableWithSummaryEntryBase<T> item) {
    this.add(item);
  }

  /// Removes all items from the collection.
  void clearBase() {
    this._thisTree.clear();
  }

  /// Determines if the item belongs to this collection.
  ///
  /// * item - _required_ - The object to locate in the collection. The value can be a `NULL` reference (Nothing in Visual Basic).
  ///
  /// Returns true if item is found in the collection; otherwise False.
  bool containsBase(_GenericTreeTableWithSummaryEntryBase<T> item) {
    if (item == null) {
      return false;
    }

    return this._thisTree.contains(item);
  }

  /// Copies the entire collection to a compatible one-dimensional array, starting at the specified index of the target array.
  ///
  /// * array - _required_ - The one-dimensional array that is the destination of the items copied from the  ArrayList. The array must have zero-based indexing.
  /// * index - _required_ - The zero-based index in an array at which copying begins.
  void copyToBase(List<dynamic> array, int index) {
    this._thisTree.copyTo(array, index);
  }

  /// Inserts a node at the specified index.
  ///
  /// * index - _required_ - Position where to insert the value
  /// * value - _required_ - Tree value need to be insert
  void insert(int index, Object value) {
    this.insert(index, value as _GenericTreeTableWithSummaryEntryBase<T>);
  }

  /// Removes the node with the specified value.
  ///
  /// * value - _required_ - Tree value needs to be remove
  void remove(Object value) {
    this.removeBase(value as _GenericTreeTableWithSummaryEntryBase<T>);
  }

  /// Indicates whether the node belongs to this tree.
  ///
  /// * value - _required_ - Value needs to be search in the tree
  ///
  /// Returns the boolean value indicating whether the node belongs to this tree.
  bool contains(Object value) {
    return this.containsBase(value as _GenericTreeTableWithSummaryEntryBase<T>);
  }

  /// Returns the index of the specified object.
  ///
  /// * value - _required_ - Value of the object.
  ///
  /// Returns index value of the object.
  int indexOf(Object value) {
    return this.indexOfBase(value as _GenericTreeTableWithSummaryEntryBase<T>);
  }

  /// Adds the specified object to the collection.
  ///
  /// * value - _required_ - Value of the object to add.
  ///
  /// Returns the zero-based collection index at which the value has been added
  int add(Object value) {
    return this.addBase(value as _GenericTreeTableWithSummaryEntryBase<T>);
  }

  /// Gets a value indicating whether the collection has a fixed size.
  ///
  /// Returns `true` if the collection has a fixed size; otherwise, `false`.

  bool get isFixedSize => this._thisTree.isFixedSize;

  /// Gets a value indicating whether access to the `ICollection` is synchronized (thread safe).
  ///
  /// Returns `True` if access to the `ICollection` is synchronized (thread safe). otherwise, `false`. Returns `false`.
  bool get isSynchronized => false;

  /// Copies the element from this collection into an array.
  ///
  /// * array - _required_ - The destination array.
  /// * index - _required_ - The starting index in the destination array.
  void copyTo(List array, int index) {
    this.copyToBase(array, index);
  }

  /// Gets an object that can be used to synchronize access to the `ICollection`.
  ///
  /// An object that can be used to synchronize access to the `ICollection`.
  Object get syncRoot => this.syncRootBase;

  /// Gets an object that can be used to synchronize access to the `ICollection`.
  ///
  /// Returns an object that can be used to synchronize access to the `ICollection`.
  Object get syncRootBase => null;

  /// Marks all summaries dirty.
  ///
  /// * notifySummariesSource - _required_ - If set to `true` notify summaries source.
  void invalidateSummariesTopDown(bool notifySummariesSource) {
    this._thisTree.invalidateSummariesTopDown(notifySummariesSource);
  }

  /// Gets a value indicating whether the tree has summaries or not.
  bool get hasSummaries => this._thisTree.hasSummaries;

  /// Gets an array of summary objects.
  ///
  /// * emptySummaries - _required_ - Summary value
  ///
  /// Returns an array of summary objects.
  List<_TreeTableSummaryBase> getSummaries(
      _TreeTableEmptySummaryArraySourceBase emptySummaries) {
    return this._thisTree.getSummaries(emptySummaries);
  }
}
