part of datagrid;

/// Integer precision's class
///
/// Holds a start and end value with integer precision.
class _Int32Span {
  int _start;
  int _end;

  /// Initializes a new instance of the [Int32Span] struct.
  ///
  /// * start - _required_ - Hold the start.
  ///  * end - _required_ - Hold the end value.
  _Int32Span(int start, int end) {
    this._start = start;
    this._end = end;
  }

  /// Gets the start.
  int get start => this._start;

  /// Sets the start.
  set start(int value) {
    this._start = value;
  }

  /// Gets the end.
  int get end => this._end;

  /// Sets the end.
  set end(int value) {
    this._end = value;
  }

  /// Gets the count (equals end - start + 1)
  int get count => this._end - this._start + 1;

  /// Sets the count
  set count(int value) {
    this.end = this.start + value - 1;
  }

  /// Indicates whether this instance and a specified object are equal.
  ///
  /// * obj - _required_ - object to compare with the current instance.
  ///
  /// Returns `True` if the given object and this instance are the same type and represent the same value,
  /// otherwise `false`.
  bool equals(Object obj) {
    if (this == obj)
      return true;
    else
      return false;
  }

  /// A 32-bit signed integer that is the hash code for this instance.
  ///
  /// Returns the hash code for this instance.
  int getHashCode() {
    return super.hashCode;
  }

  /// Implements the operator == for comparing the given objects.
  ///
  /// * obj - _required_ - Object to compare with the current instance.
  ///
  /// Returns the comparison result of the operator.
  @override
  bool operator ==(dynamic obj) {
    return this.equals(obj);
  }

  /// Gets the hashcode
  ///
  /// Returns the hashcode.
  @override
  int get hashCode => getHashCode();
}
